% Show global and local identifiability of f and g respectively 

% parameters
syms k01 k02 k03 k12 k13 k21 k32
p = [k01 k02 k03 k12 k13 k21 k32];

% elementary symmetric functions
E12 = @(z1,z2)(z1 + z2);
E22 = @(z1,z2)(z1*z2);
E13 = @(z1,z2,z3)(z1 + z2 + z3);
E23 = @(z1,z2,z3)(z1*z2 + z1*z3 + z2*z3);
E33 = @(z1,z2,z3)(z1*z2*z3);

% coefficients of input-output equations
c1 = E13(-(k01+k21),-(k02+k12+k32),-(k03+k13));
c2 = E23(-(k01+k21),-(k02+k12+k32),-(k03+k13))-k12*k21;
c3 = E33(-(k01+k21),-(k02+k12+k32),-(k03+k13)) + k12*k21*(k03+k13) + k21*k13*k32;
c4 = E12(-(k02+k12+k32),-(k03+k13));
c5 = E22(-(k02+k12+k32),-(k03+k13));
c = [c1;c2;c3;c4;c5];

f = k01 + k21;
g = k02 + k12 + k32;

disp(['f - (c4 - c1) = ',char(simplify(f - (c4 - c1)))]);
disp(['g^2 + c4*g + c5 = ',char(simplify(g^2 + c4*g + c5))]);



