% Perform multihomogeneous trace test on the points 

[n,P0] = ReadInStart(6,'start33');
[~,P1] = ReadInStart(6,'start33_out');
[~,P2] = ReadInStart(6,'start33_in');

Z0 = zeros(n,11);
Z1 = zeros(n,11);
Z2 = zeros(n,11);
H1 = zeros(n,1);
H2 = zeros(n,1);

for j = 1:n
	Z0(j,:) = [P0(j,:) P0(j,1:5)*P0(j,6)];
	Z1(j,:) = [P1(j,:) P1(j,1:5)*P1(j,6)];
	Z2(j,:) = [P2(j,:) P2(j,1:5)*P2(j,6)];
    H1(j) = P0(j,1:5)*[4; 5; -2; 4; -2] - 1;
    H2(j) = [2 4 -1 -6 -4]*[[-2; -31; 5; -1; -30] + [-5; -3; -3; 2; 4]*P0(j,6)] + 7;
end;

Trace = abs(sum(sum(Z1 + Z2 - 2*Z0)));

disp(['trace is ',num2str(Trace)]);
disp(['number solve H1: ',num2str(sum(abs(H1)<1e-10))]);
disp(['number solve H2: ',num2str(sum(abs(H2)<1e-10))]);



