% Perform multihomogeneous trace test on the points 

[n,P0] = ReadInStart(25,'start35_2');
[~,P1] = ReadInStart(25,'start35_2_out');
[~,P2] = ReadInStart(25,'start35_2_in');

Z0 = zeros(n,3);
Z1 = zeros(n,3);
Z2 = zeros(n,3);
H1 = zeros(n,1);
H2 = zeros(n,1);

for j = 1:n
	Z0(j,:) = [P0(j,[5,25]) P0(j,5)*P0(j,25)];
	Z1(j,:) = [P1(j,[5,25]) P1(j,5)*P1(j,25)];
	Z2(j,:) = [P2(j,[5,25]) P2(j,5)*P2(j,25)];
    H1(j) = P0(j,5) - 4/3; 
    H2(j) = [3 4 5 1 1 -4 4 -1]*[[1; 4; 3; -2; -1; -3; 3; 4]*P0(j,25) + [0.5; -0.03; -0.15; -0.2; -0.2; -0.17; -0.16; -0.15]] - 0.42;
end;

Trace = abs(sum(sum(Z1 + Z2 - 2*Z0)));

disp(['trace is ',num2str(Trace)]);
disp(['number solve H1: ',num2str(sum(abs(H1)<1e-10))]);
disp(['number solve H2: ',num2str(sum(abs(H2)<1e-10))]);



