% test identifiability for MAPK
rng(1);

% 22 parameters
syms a00 a01 a10 b00 b01 b10 c0001 c0010 c0011 c0111 c1011 alpha01 alpha10 alpha11 beta01 beta10 beta11 gamma0100 gamma1000 gamma1100 gamma1101 gamma1110;
p = [a00 a01 a10 b00 b01 b10 c0001 c0010 c0011 c0111 c1011 alpha01 alpha10 alpha11 beta01 beta10 beta11 gamma0100 gamma1000 gamma1100 gamma1101 gamma1110];

% upper bound
for r = 0:8

    % setup functions and variables
    syms t;
    varX = [];
    varU = [];
    varY = [];
    X = zeros(12,1)*p(1);
    Y = zeros(4,1)*p(1);
    U = 0*p(1);
    for j = 0:r+1
        for k = 1:12
            eval(['syms x',num2str(k),'_',num2str(j)]);
            X(k) = X(k) + eval(['x',num2str(k),'_',num2str(j)])*t^j; %/factorial(j);
            varX = [varX eval(['x',num2str(k),'_',num2str(j)])];
        end;

        if j <= r
            for k = 1:4
                eval(['syms y',num2str(k),'_',num2str(j)]);
                Y(k) = Y(k) + eval(['y',num2str(k),'_',num2str(j)])*t^j; %/factorial(j);
                varY = [varY eval(['y',num2str(k),'_',num2str(j)])];
            end;
        end;
    end;
    Xd = diff(X,t);

    KS00 = X(1);
    KS01 = X(2);
    KS10 = X(3);
    FS01 = X(4);
    FS10 = X(5);
    FS11 = X(6);
    K = X(7);
    F = X(8);
    S00 = X(9);
    S01 = X(10);
    S10 = X(11);
    S11 = X(12);

    KS00_d = Xd(1);
    KS01_d = Xd(2);
    KS10_d = Xd(3);
    FS01_d = Xd(4);
    FS10_d = Xd(5);
    FS11_d = Xd(6);
    K_d = Xd(7);
    F_d = Xd(8);
    S00_d = Xd(9);
    S01_d = Xd(10);
    S10_d = Xd(11);
    S11_d = Xd(12);

    G1 = -KS00_d -a00*K*S00 + b00*KS00 + gamma0100*FS01 + gamma1000*FS10 + gamma1100*FS11;
    G2 = -KS01_d -a01*K*S01+b01*KS01+c0001*KS00-alpha01*F*S01+beta01*FS01+gamma1101*FS11;
    G3 = -KS10_d -a10*K*S10+b10*KS10+c0010*KS00-alpha10*F*S10+beta10*FS10+gamma1110*FS11;
    G4 = -FS01_d -alpha11*F*S11+beta11*FS11+c0111*KS01+c1011*KS10+c0011*KS00;
    G5 = -FS10_d +a00*K*S00-(b00+c0001+c0010+c0011)*KS00;
    G6 = -FS11_d +a01*K*S01-(b01+c0111)*KS01;
    G7 = -K_d +a10*K*S10-(b10+c1011)*KS10;
    G8 = -F_d +alpha01*F*S01-(beta01+gamma0100)*FS01;
    G9 = -S00_d +alpha10*F*S10-(beta10+gamma1000)*FS10;
    G10 = -S01_d +alpha11*F*S11-(beta11+gamma1101+gamma1110+gamma1100)*FS11;
    G11 = -S10_d -a00*K*S00+(b00+c0001+c0010+c0011)*KS00-a01*K*S01+(b01+c0111)*KS01-a10*K*S10+(b10+c1011)*KS10;
    G12 = -S11_d -alpha01*F*S01+(beta01+gamma0100)*FS01-alpha10*F*S10+(beta10+gamma1000)*FS10-alpha11*F*S11+(beta11+gamma1101+gamma1110+gamma1100)*FS11;

    G13 = S00 - Y(1);
    G14 = S01 - Y(2); 
    G15 = S10 - Y(3); 
    G16 = S11 - Y(4);

    G = [G1;G2;G3;G4;G5;G6;G7;G8;G9;G10;G11;G12;G13;G14;G15;G16];

    % compute coefficients of 1,t,t^2,..,t^r
    F = [];
    for j = 0:r
        F = [F;subs(diff(G,t,j),t,0)/factorial(j)];
    end;

    % compute a solution
    x0 = [x1_0 x2_0 x3_0 x4_0 x5_0 x6_0 x7_0 x8_0 x9_0 x10_0 x11_0 x12_0];
    x0e = rand(size(x0))*2-1 + 1i*(rand(size(x0))*2-1);

    pe = rand(size(p))*2-1 + 1i*(rand(size(p))*2-1);
    varUe = rand(size(varU))*2-1 + 1i*(rand(size(varU))*2-1);
    Fe = subs(F,[x0 p varU],[x0e pe varUe]);

    varX1 = varX(13:end);
    varX1e = zeros(1,length(varX1));
    varYe = zeros(size(varY));
    % compute unique solution to linear system
    for j = 0:r
        S = solve(Fe(j*length(G)+1:(j+1)*length(G)));
        for k = 1:12
            varX1e(j*12+k) = double(eval(['S.',char(varX1(j*12+k))]));
        end;
        for k = 1:4
            varYe(j*4+k) = double(eval(['S.',char(varY(j*4+k))]));        
        end;
        Fe = subs(Fe,[varX1(j*12+1:(j+1)*12) varY(j*4+1:(j+1)*4)],[varX1e(j*12+1:(j+1)*12) varYe(j*4+1:(j+1)*4)]);
    end;    

    % compute rank of Jacobian w.r.t. p, x
    J = jacobian(F,[p varX]);
    Je = double(subs(J,[x0 varX1 p varU varY],[x0e varX1e pe varUe varYe]));
    rPX = double(vpa(rank(Je,1e-12)));
    nPX = double(size(null(Je),2));
    cPX = size(J,2) - rPX;

    % compute rank of Jacobian w.r.t. x
    J = jacobian(F,[varX]);
    Je = double(subs(J,[x0 varX1 p varU varY],[x0e varX1e pe varUe varYe]));
    rX = double(vpa(rank(Je,1e-12)));
    nX = double(size(null(Je),2));
    cX = size(J,2) - rX;

    disp(' ');
    disp(['r = ',num2str(r)]);
    disp(['corank of p,x = ',num2str(cPX)]);
    disp(['corank of x = ',num2str(cX)]);
    disp(['null of p,x = ',num2str(nPX)]);
    disp(['null of x = ',num2str(nX)]);
end;
